CREATE OR ALTER procedure ADD_REM_CONTACT (
    USERS_ID integer,
    CONTACT_TYPE_ID integer,
    PERSON_ID integer,
    CONTACT_RESULT_ID integer,
    DT_CONTACT timestamp,
    DT_CONTACT_NEXT timestamp,
    COMMENTS blob sub_type 0 segment size 80,
    ACCESS integer,
    NOMENCLATURE_ID integer)
returns (
    CONTACT_FINAL_ID integer,
    ERROR integer)
as
BEGIN
    IF (EXISTS (SELECT
                    PERSON.USERS_ID
                FROM
                    PERSON
                WHERE
                (PERSON.ID =:PERSON_ID) AND
                (PERSON.USERS_ID =:USERS_ID)))
    THEN
        BEGIN
            ERROR = 0;
        END
    ELSE
    IF (ACCESS <> 0)
    THEN
        ERROR = 0;
    ELSE
        ERROR = 1;


    IF (ERROR = 0)
    THEN
        BEGIN
            CONTACT_FINAL_ID = GEN_ID(GEN_CONTACT_ID, 1);

            INSERT INTO CONTACT (
                ID,
                PERSON_ID,
                CONTACT_TYPE_ID,
                CONTACT_RESULT_ID,
                USERS_ID,
                DT_CONTACT,
                DT_CONTACT_NEXT,
                COMMENTS,
                NOMENCLATURE_ID
            )
            VALUES (
                :CONTACT_FINAL_ID,
                :PERSON_ID,
                :CONTACT_TYPE_ID,
                :CONTACT_RESULT_ID,
                :USERS_ID,
                :DT_CONTACT,
                :DT_CONTACT_NEXT,
                :COMMENTS,
                :NOMENCLATURE_ID
            );
        END

  SUSPEND;
END;
