CREATE OR ALTER procedure SET_VERSION (
    NUMBER varchar(88))
as
declare variable TEMP integer;
begin
  TEMP = 0;
  FOR
    SELECT
      COUNT(*)
    FROM
      USERS_SETTINGS
    WHERE
      USERS_ID = 2
    INTO
      :TEMP
  DO
    BEGIN
      IF (:TEMP > 0)
      THEN
        BEGIN
          UPDATE
            USERS_SETTINGS
          SET
            SETTINGS = :NUMBER
          WHERE
            USERS_ID = 2;
        END
      ELSE
        BEGIN
          INSERT INTO
            USERS_SETTINGS
            (USERS_ID, SETTINGS)
          VALUES
            (2, :NUMBER);
        END
    END
end;

CREATE OR ALTER procedure SEND_OLD_ORGANIZATION (
    USER_ID integer,
    SEND_USER_ID integer,
    LAST_DT_CONTACT timestamp,
    SEND_PERSON integer,
    SEND_CONTACT integer,
    ACTIVITY_ID integer)
returns (
    COUNT_SEND integer)
as
declare variable ORGANIZATION_ID integer;
begin
  COUNT_SEND = 0;

  FOR
    SELECT DISTINCT
      ORGANIZATION.ID
    FROM
      ORGANIZATION
    WHERE
      (ORGANIZATION.USERS_ID = :USER_ID) AND
      ((:ACTIVITY_ID = -1) or (ORGANIZATION.ACTIVITY_ID <> :ACTIVITY_ID)) AND
      (ORGANIZATION.DT_CREATE <= :LAST_DT_CONTACT) AND
      (ORGANIZATION.ID NOT IN (SELECT
                                 PERSON.ORGANIZATION_ID
                               FROM
                                 PERSON
                                 LEFT JOIN CONTACT ON CONTACT.PERSON_ID = PERSON.ID
                               WHERE
                                (PERSON.ORGANIZATION_ID = ORGANIZATION.ID) AND
                                (CONTACT.USERS_ID = :USER_ID) AND
                                (CONTACT.DT_CONTACT > :LAST_DT_CONTACT)))
    INTO
      :ORGANIZATION_ID
  DO
    BEGIN
      COUNT_SEND = COUNT_SEND + 1;

      UPDATE
        ORGANIZATION    
      SET
        USERS_ID = :SEND_USER_ID
      WHERE
        ID = :ORGANIZATION_ID;

      IF (:SEND_PERSON = 1)
      THEN
        BEGIN
          UPDATE
            PERSON
          SET
            USERS_ID = :SEND_USER_ID
          WHERE
            (ORGANIZATION_ID = :ORGANIZATION_ID) AND
            (USERS_ID = :USER_ID);
        END

      IF (:SEND_CONTACT = 1)
      THEN
        BEGIN
          UPDATE
            CONTACT
          SET
            CONTACT.USERS_ID = :SEND_USER_ID
          WHERE
            (CONTACT.USERS_ID = :USER_ID) AND
            (CONTACT.PERSON_ID IN (SELECT
                                     PERSON.ID
                                   FROM
                                     PERSON
                                   WHERE
                                     PERSON.ORGANIZATION_ID = :ORGANIZATION_ID));
        END

    END

  SUSPEND;
end;

EXECUTE PROCEDURE SET_VERSION('3.1.31');