CREATE GENERATOR GEN_PROGRAM_LABEL_ID;

CREATE TABLE PROGRAM_LABEL (
    ID          INTEGER NOT NULL,
    ID_PROGRAM  INTEGER NOT NULL,
    ID_WINDOW   INTEGER NOT NULL,
    LABEL_NAME  VARCHAR(32) NOT NULL,
    LABEL_TEXT  VARCHAR(192) NOT NULL
);

ALTER TABLE PROGRAM_LABEL ADD CONSTRAINT UNQ1_PROGRAM_LABEL UNIQUE (ID_PROGRAM, ID_WINDOW, LABEL_NAME);
ALTER TABLE PROGRAM_LABEL ADD CONSTRAINT PK_PROGRAM_LABEL PRIMARY KEY (ID);

CREATE OR ALTER TRIGGER PROGRAM_LABEL_BI FOR PROGRAM_LABEL
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL)
  THEN
    NEW.ID = GEN_ID(GEN_PROGRAM_LABEL_ID, 1);
END;

DELETE FROM PROGRAM_LABEL;

ALTER SEQUENCE GEN_PROGRAM_LABEL_ID RESTART WITH 0;

INSERT INTO PROGRAM_LABEL (ID_PROGRAM, ID_WINDOW, LABEL_NAME, LABEL_TEXT) VALUES (0, 0, 'ReqINN', ' (10)');
INSERT INTO PROGRAM_LABEL (ID_PROGRAM, ID_WINDOW, LABEL_NAME, LABEL_TEXT) VALUES (0, 0, 'ReqKPP', ' (9)');
INSERT INTO PROGRAM_LABEL (ID_PROGRAM, ID_WINDOW, LABEL_NAME, LABEL_TEXT) VALUES (0, 0, 'ReqOKPO', ' (8)');
INSERT INTO PROGRAM_LABEL (ID_PROGRAM, ID_WINDOW, LABEL_NAME, LABEL_TEXT) VALUES (0, 0, 'ReqOKVED', '');
INSERT INTO PROGRAM_LABEL (ID_PROGRAM, ID_WINDOW, LABEL_NAME, LABEL_TEXT) VALUES (0, 0, 'ReqBIK', ' (9)');

EXECUTE PROCEDURE SET_VERSION('3.1.41');