ALTER TABLE CONTACT_RESULT_AUTO ADD PRIORITY INTEGER;

CREATE OR ALTER TRIGGER CONTACT_AI FOR CONTACT
ACTIVE AFTER INSERT POSITION 0
AS
    DECLARE VARIABLE DAYSLEFT INTEGER;
    DECLARE VARIABLE PRIORITY INTEGER;
    DECLARE VARIABLE USERS_ID INTEGER;
    DECLARE VARIABLE REMINDER BLOB SUB_TYPE 1 SEGMENT SIZE 80;
    DECLARE VARIABLE DT_REMINDER TIMESTAMP;
BEGIN
  UPDATE ORGANIZATION
  SET
    ORGANIZATION.DT_LASTMODIFY = 'NOW'
  WHERE
    ORGANIZATION.ID = (SELECT PERSON.ORGANIZATION_ID
                        FROM
                            PERSON
                        WHERE
                            PERSON.ID =  NEW.PERSON_ID);

  FOR
    SELECT
        CONTACT_RESULT_AUTO.USERS_ID,
        CONTACT_RESULT_AUTO.DAYSLEFT,
        CONTACT_RESULT_AUTO.PRIORITY,
        CONTACT_RESULT_AUTO.REMINDER
    FROM
        CONTACT_RESULT_AUTO
    WHERE
        CONTACT_RESULT_AUTO.CONTACT_RESULT_ID = NEW.CONTACT_RESULT_ID
  INTO
    :USERS_ID,
    :DAYSLEFT,
    :PRIORITY,
    :REMINDER
  DO
    BEGIN
        DT_REMINDER = CURRENT_DATE + DAYSLEFT;

        IF (USERS_ID IS NULL)
        THEN
            USERS_ID = NEW.USERS_ID;

        INSERT INTO REMINDER
        (
            REMINDER.PERSON_ID,
            REMINDER.FROM_USERS_ID,
            REMINDER.TO_USERS_ID,
            REMINDER.CONTACT_START_ID,
            REMINDER.CONTACT_FINAL_ID,
            REMINDER.DT_REMINDER,
            REMINDER.REMINDER,
            REMINDER.STATUS,
            REMINDER.PRIORITY
        )
        VALUES
        (
            NEW.PERSON_ID,
            NEW.USERS_ID,
            :USERS_ID,
            NEW.ID,
            NULL, 
            :DT_REMINDER,
            :REMINDER, 
            0,
            :PRIORITY
        );
    END
END;

CREATE OR ALTER TRIGGER CONTACT_AU FOR CONTACT
ACTIVE AFTER UPDATE POSITION 0
AS
    DECLARE VARIABLE DAYSLEFT INTEGER;
    DECLARE VARIABLE PRIORITY INTEGER;
    DECLARE VARIABLE USERS_ID INTEGER;
    DECLARE VARIABLE REMINDER BLOB SUB_TYPE 1 SEGMENT SIZE 80;
    DECLARE VARIABLE DT_REMINDER TIMESTAMP;
BEGIN
  IF (NEW.CONTACT_RESULT_ID <> OLD.CONTACT_RESULT_ID)
  THEN
    BEGIN

  FOR
    SELECT
        CONTACT_RESULT_AUTO.USERS_ID,
        CONTACT_RESULT_AUTO.DAYSLEFT,
        CONTACT_RESULT_AUTO.PRIORITY,
        CONTACT_RESULT_AUTO.REMINDER
    FROM
        CONTACT_RESULT_AUTO
    WHERE
        CONTACT_RESULT_AUTO.CONTACT_RESULT_ID = NEW.CONTACT_RESULT_ID
  INTO
    :USERS_ID,
    :DAYSLEFT,
    :PRIORITY,
    :REMINDER
  DO
    BEGIN
        DT_REMINDER = CURRENT_DATE + DAYSLEFT;

        IF (USERS_ID IS NULL)
        THEN
            USERS_ID = NEW.USERS_ID;

        INSERT INTO REMINDER
        (
            REMINDER.PERSON_ID,
            REMINDER.FROM_USERS_ID,
            REMINDER.TO_USERS_ID,
            REMINDER.CONTACT_START_ID,
            REMINDER.CONTACT_FINAL_ID,
            REMINDER.DT_REMINDER,
            REMINDER.REMINDER,
            REMINDER.STATUS,
            REMINDER.PRIORITY
        )
        VALUES
        (
            NEW.PERSON_ID,
            NEW.USERS_ID,
            :USERS_ID,
            NEW.ID,
            NULL, 
            :DT_REMINDER,
            :REMINDER, 
            0,
            :PRIORITY
        );
    END

    END
END;