ALTER TABLE EVENT_PROJECTS ADD SUPPLIER_ORGANIZATION_ID INTEGER;

ALTER TABLE EVENT_PROJECTS ADD CONSTRAINT FK_EVENT_PROJECTS_8 FOREIGN KEY (SUPPLIER_ORGANIZATION_ID) REFERENCES ORGANIZATION(ID) ON DELETE SET NULL;

CREATE TRIGGER ORGANIZATION_BU FOR ORGANIZATION
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
  SELECT
    COUNT(*)
  FROM
    ORGANIZATION_DOCUMENT
  WHERE
    ORGANIZATION_ID = NEW.ID
  INTO
    NEW.DOCUMENT_COUNT;
END;

CREATE OR ALTER TRIGGER CONTACT_BU FOR CONTACT
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN

  IF (NEW.NOMENCLATURE_ID < 1)
  THEN
    NEW.NOMENCLATURE_ID = NULL;

  SELECT
    COUNT(*)
  FROM
    CONTACT_DOCUMENT
  WHERE
    CONTACT_ID = NEW.ID
  INTO
    NEW.DOCUMENT_COUNT;

END;

CREATE OR ALTER TRIGGER ORGANIZATION_DOCUMENT_AI FOR ORGANIZATION_DOCUMENT
ACTIVE AFTER INSERT POSITION 0
AS
BEGIN
  UPDATE ORGANIZATION
  SET
    DOCUMENT_COUNT = (SELECT
                         COUNT(*)
                      FROM
                         ORGANIZATION_DOCUMENT
                      WHERE
                         ORGANIZATION_ID = NEW.ORGANIZATION_ID)
  WHERE
    ID = NEW.ORGANIZATION_ID;
END;

CREATE OR ALTER TRIGGER ORGANIZATION_DOCUMENT_AD FOR ORGANIZATION_DOCUMENT
ACTIVE AFTER DELETE POSITION 0
AS
BEGIN
  UPDATE ORGANIZATION
  SET
    DOCUMENT_COUNT = (SELECT
                         COUNT(*)
                      FROM
                         ORGANIZATION_DOCUMENT
                      WHERE
                         ORGANIZATION_ID = OLD.ORGANIZATION_ID)
  WHERE
    ID = OLD.ORGANIZATION_ID;
END;

CREATE OR ALTER TRIGGER CONTACT_DOCUMENT_AI FOR CONTACT_DOCUMENT
ACTIVE AFTER INSERT POSITION 0
AS
BEGIN
  UPDATE CONTACT
  SET
    DOCUMENT_COUNT = (SELECT
                         COUNT(*)
                      FROM
                         CONTACT_DOCUMENT
                      WHERE
                         CONTACT_ID = NEW.CONTACT_ID)
  WHERE
    ID = NEW.CONTACT_ID;
END;

CREATE OR ALTER TRIGGER CONTACT_DOCUMENT_AD FOR CONTACT_DOCUMENT
ACTIVE AFTER DELETE POSITION 0
AS
BEGIN
  UPDATE CONTACT
  SET
    DOCUMENT_COUNT = (SELECT
                         COUNT(*)
                      FROM
                         CONTACT_DOCUMENT
                      WHERE
                         CONTACT_ID = OLD.CONTACT_ID)
  WHERE
    ID = OLD.CONTACT_ID;
END;

CREATE OR ALTER TRIGGER EVENT_PROJECTS_DOCUMENT_AI FOR EVENT_PROJECTS_DOCUMENT
ACTIVE AFTER INSERT POSITION 0
AS
BEGIN
  UPDATE EVENT_PROJECTS
  SET
    DOCUMENT_COUNT = (SELECT
                         COUNT(*)
                      FROM
                         EVENT_PROJECTS_DOCUMENT
                      WHERE
                         EVENT_PROJECTS_ID = NEW.EVENT_PROJECTS_ID)
  WHERE
    ID = NEW.EVENT_PROJECTS_ID;
END;

CREATE OR ALTER TRIGGER EVENT_PROJECTS_DOCUMENT_AD FOR EVENT_PROJECTS_DOCUMENT
ACTIVE AFTER DELETE POSITION 0
AS
BEGIN
  UPDATE EVENT_PROJECTS
  SET
    DOCUMENT_COUNT = (SELECT
                         COUNT(*)
                      FROM
                         EVENT_PROJECTS_DOCUMENT
                      WHERE
                         EVENT_PROJECTS_ID = OLD.EVENT_PROJECTS_ID)
  WHERE
    ID = OLD.EVENT_PROJECTS_ID;
END;

DROP TRIGGER EVENT_PROJECTS_AID;

CREATE OR ALTER TRIGGER EVENT_PROJECTS_BU FOR EVENT_PROJECTS
ACTIVE BEFORE UPDATE POSITION 0
AS
BEGIN
  SELECT
    COUNT(*)
  FROM
    EVENT_PROJECTS_DOCUMENT
  WHERE
    EVENT_PROJECTS_ID = NEW.ID
  INTO
    NEW.DOCUMENT_COUNT;
END;

UPDATE
  ORGANIZATION
SET
  ORGANIZATION.DOCUMENT_COUNT = (SELECT
                                    COUNT(*)
                                  FROM
                                    ORGANIZATION_DOCUMENT
                                  WHERE
                                    ORGANIZATION_DOCUMENT.ORGANIZATION_ID = ORGANIZATION.ID);

UPDATE
  CONTACT
SET
  CONTACT.DOCUMENT_COUNT = (SELECT
                              COUNT(*)
                            FROM
                              CONTACT_DOCUMENT
                            WHERE
                              CONTACT_DOCUMENT.CONTACT_ID = CONTACT.ID);

UPDATE
  EVENT_PROJECTS
SET
  EVENT_PROJECTS.DOCUMENT_COUNT = (SELECT
                                     COUNT(*)
                                   FROM
                                     EVENT_PROJECTS_DOCUMENT
                                   WHERE
                                     EVENT_PROJECTS_DOCUMENT.EVENT_PROJECTS_ID = EVENT_PROJECTS.ID);

EXECUTE PROCEDURE SET_VERSION('3.1.45 (1)');