CREATE OR ALTER procedure EXCHANGE_ORG (
    VAR_OLD_USERS_ID integer,
    VAR_NEW_USERS_ID integer,
    VAR_ORGAN_ID integer,
    VAR_DOWNLEVEL integer)
returns (
    VAR_PERS_COUNT integer,
    VAR_CONT_COUNT integer)
as
BEGIN

VAR_PERS_COUNT = 0;
VAR_CONT_COUNT = 0;

  UPDATE ORGANIZATION
  SET
    USERS_ID = :VAR_NEW_USERS_ID
  WHERE
    (USERS_ID = :VAR_OLD_USERS_ID)
    AND
    (ID = :VAR_ORGAN_ID);

  IF (VAR_DOWNLEVEL = 1)
  THEN
    SUSPEND;

 SELECT
    COUNT (P.ID)
  FROM
    PERSON P
  WHERE
    P.ORGANIZATION_ID = :VAR_ORGAN_ID
  INTO
    :VAR_PERS_COUNT;

  UPDATE PERSON
  SET
    USERS_ID = :VAR_NEW_USERS_ID
  WHERE
    ORGANIZATION_ID = :VAR_ORGAN_ID;

  UPDATE AGREEMENT
  SET
    USERS_ID = :VAR_NEW_USERS_ID
  WHERE
    ORGANIZATION_ID = :VAR_ORGAN_ID;

 SELECT
    COUNT (C.ID)
  FROM
    (CONTACT C LEFT JOIN PERSON P ON C.PERSON_ID = P.ID)
  WHERE
    P.ORGANIZATION_ID = :VAR_ORGAN_ID
  INTO
    :VAR_CONT_COUNT;

  UPDATE CONTACT
  SET
    USERS_ID = :VAR_NEW_USERS_ID
  WHERE
    PERSON_ID IN (SELECT
                     ID
                   FROM
                     PERSON
                   WHERE
                     ORGANIZATION_ID = :VAR_ORGAN_ID);

  SUSPEND;

END;
